
/* "My very first java class :)"
* 
* I start counting from 1 (not 0). So players are 1,2,3,4,5,6 (not 0-5)
*
* Data structure:
* 	The board is an array of hole objects (hole.java), each hole have
* 	  six pointers to its neighbours, a boolean that is true if the hole
* 	  is empty, and some atributes about the peg if the hole is not empty.
*
* 	We also hava a matrix (currentPositions) with the positions of all the
* 	  pegs. currentPositions[4][2] = position of four player - second peg
*
* 	And another matrix (nests) with the nests. We use this one to init.
* 	  the board, and checking the wineers.
*
* 	Array id[] is use to know the "nest" of each player
*
*
* Board:
*
*                                     001
*                                  002   003
*                               004   005   006
*                            007   008   009   010 
* 011   012   013   014   015   016   017   018   019   020   021   022   023
*    024   025   026   027   028   029   030   031   032   033   034   035
*       036   037   038   039   040   041   042   043   044   045   046
*          047   048   049   050   051   052   053   054   055   056
*             057   058   059   060   061   062   063   064   065
*          066   067   068   069   070   071   072   073   074   075
*       076   077   078   079   080   081   082   083   084   085   086
*    087   088   089   090   091   092   093   094   095   096   097   098
* 099   100   101   102   103   104   105   106   107   108   109   110   111
*                          112   113   114   115
*                             116   117   118
*                                119   120
*                                   121
*
*Nests:                Directions:
*
*        1                6 1
*	 6 2              5 X 2 
*	 5 3               4 3
*	  4
*
* The packege pkBoard containts the classes board and hole
*/
package pkBoard;
import pkBoard.hole;

/**
 * Class board
 * @Version 0
 * @Author Csar Prez <perces-1@student.luth.se>
 * Date: 5 November 2001
 * Methods and use:
 * 	board myBoard = new board(numberOfPlayers);
 * 	boolean = myBoard.checkMovement(player, peg, arrayWithDirections);
 * 	myBoard.update (player, peg, destinationHole);
 * 	boolen[nPlayers] = myBoard.winner();
 *      public int getPlayer (int hole)
 *      public int getPeg (int hole)
 *      public int getNPlayers ()
 *
 *	public int getOppositeNest (int myID)
 *   	public boolean inNest (int hole, int ID)
 *	public int getNeighbours (int hole, int direction)
 public int getHole (int ID, int peg)
 */
public class Board {
    public final int NHOLES = 122; // number of holes in the board
    hole[] board = new hole[NHOLES];
    int[][] currentPositions = new int[7][11];
    final static int[][] nests =  {
         {
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        },  {
            0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10
        },  {
            0, 23, 22, 35, 21, 34, 46, 20, 33, 45, 56
        },  {
            0, 111, 98, 110, 86, 97, 109, 75, 85, 96, 108
        },  {
            0, 121, 119, 120, 116, 117, 118, 112, 113, 114, 115
        },  {
            0, 99, 100, 87, 101, 88, 76, 102, 89, 77, 66
        },  {
            0, 11, 24, 12, 36, 25, 13, 47, 37, 26, 14
        }
    };
    int[] id;
    
    /********* METHODS ************/
    
    // constructor
    public Board(int[] array) {
        id = array;
        initLinks(); // init the links with the neighbours of each hole
        initPegs(id); // put the pegs in the board
    } /* end board constructor; */
    private void initLinks() { /* hard coded */
        
        /*
        *           6 1
        *          5 X 2     Z = zone; X = hole
        *           4 3
        *           
        *                    1   2   3   4   5   6   Z
        */
        for(int i = 1;i < NHOLES;i++) {
            board[i] = new hole();
        }
        board[1].setLinks(-1, -1, 3, 2, -1, -1, 1);
        board[2].setLinks(1, 3, 5, 4, -1, -1, 1);
        board[3].setLinks(-1, -1, 6, 5, 2, 1, 1);
        board[4].setLinks(2, 5, 8, 7, -1, -1, 1);
        board[5].setLinks(3, 6, 9, 8, 4, 2, 1);
        board[6].setLinks(-1, -1, 10, 9, 5, 3, 1);
        board[7].setLinks(4, 8, 16, 15, -1, -1, 1);
        board[8].setLinks(5, 9, 17, 16, 7, 4, 1);
        board[9].setLinks(6, 10, 18, 17, 8, 5, 1);
        board[10].setLinks(-1, -1, 19, 18, 9, 6, 1);
        board[11].setLinks(-1, 12, 24, -1, -1, -1, 6);
        board[12].setLinks(-1, 13, 25, 24, 11, -1, 6);
        board[13].setLinks(-1, 14, 26, 25, 12, -1, 6);
        board[14].setLinks(-1, 15, 27, 26, 13, -1, 6);
        board[15].setLinks(7, 16, 28, 27, 14, -1, 6);
        board[16].setLinks(8, 17, 29, 28, 15, 7, 7);
        board[17].setLinks(9, 18, 30, 29, 16, 8, 7);
        board[18].setLinks(10, 19, 31, 30, 17, 9, 7);
        board[19].setLinks(-1, 20, 32, 31, 18, 10, 7);
        board[20].setLinks(-1, 21, 33, 32, 19, -1, 2);
        board[21].setLinks(-1, 22, 34, 33, 20, -1, 2);
        board[22].setLinks(-1, 23, 35, 34, 21, -1, 2);
        board[23].setLinks(-1, -1, -1, 35, 22, -1, 2);
        board[24].setLinks(12, 25, 36, -1, -1, 11, 6);
        board[25].setLinks(13, 26, 37, 36, 24, 12, 6);
        board[26].setLinks(14, 27, 38, 37, 25, 13, 6);
        board[27].setLinks(15, 28, 39, 38, 26, 14, 7);
        board[28].setLinks(16, 29, 40, 39, 27, 15, 7);
        board[29].setLinks(17, 30, 41, 40, 28, 16, 7);
        board[30].setLinks(18, 31, 42, 41, 29, 17, 7);
        board[31].setLinks(19, 32, 43, 42, 30, 18, 7);
        board[32].setLinks(20, 33, 44, 43, 31, 19, 7);
        board[33].setLinks(21, 34, 45, 44, 32, 20, 2);
        board[34].setLinks(22, 35, 46, 45, 33, 21, 2);
        board[35].setLinks(23, -1, -1, 46, 34, 22, 2);
        board[36].setLinks(25, 37, 47, -1, -1, 24, 6);
        board[37].setLinks(26, 38, 48, 47, 36, 25, 6);
        board[38].setLinks(27, 39, 49, 48, 37, 26, 7);
        board[39].setLinks(28, 40, 50, 49, 38, 27, 7);
        board[40].setLinks(29, 41, 51, 50, 39, 28, 7);
        board[41].setLinks(30, 42, 52, 51, 40, 29, 7);
        board[42].setLinks(31, 43, 53, 52, 41, 30, 7);
        board[43].setLinks(32, 44, 54, 53, 42, 31, 7);
        board[44].setLinks(33, 45, 55, 54, 43, 32, 7);
        board[45].setLinks(34, 46, 56, 55, 44, 33, 2);
        board[46].setLinks(35, -1, -1, 56, 45, 34, 2);
        board[47].setLinks(37, 48, 57, -1, -1, 36, 6);
        board[48].setLinks(38, 49, 58, 57, 47, 37, 7);
        board[49].setLinks(39, 50, 59, 58, 48, 38, 7);
        board[50].setLinks(40, 51, 60, 59, 49, 39, 7);
        board[51].setLinks(41, 52, 61, 60, 50, 40, 7);
        board[52].setLinks(42, 53, 62, 61, 51, 41, 7);
        board[53].setLinks(43, 54, 63, 62, 52, 42, 7);
        board[54].setLinks(44, 55, 64, 63, 53, 43, 7);
        board[55].setLinks(45, 56, 65, 64, 54, 44, 7);
        board[56].setLinks(46, -1, -1, 65, 55, 45, 2);
        board[57].setLinks(48, 58, 67, 66, -1, 47, 7);
        board[58].setLinks(49, 59, 68, 67, 57, 48, 7);
        board[59].setLinks(50, 60, 69, 68, 58, 49, 7);
        board[60].setLinks(51, 61, 70, 69, 59, 50, 7);
        board[61].setLinks(52, 62, 71, 70, 60, 51, 7);
        board[62].setLinks(53, 63, 72, 71, 61, 52, 7);
        board[63].setLinks(54, 64, 73, 72, 62, 53, 7);
        board[64].setLinks(55, 65, 74, 73, 63, 54, 7);
        board[65].setLinks(56, -1, 75, 74, 64, 55, 7);
        board[66].setLinks(57, 67, 77, 76, -1, -1, 5);
        board[67].setLinks(58, 68, 78, 77, 66, 57, 7);
        board[68].setLinks(59, 69, 79, 78, 67, 58, 7);
        board[69].setLinks(60, 70, 80, 79, 68, 59, 7);
        board[70].setLinks(61, 71, 81, 80, 69, 60, 7);
        board[71].setLinks(62, 72, 82, 81, 70, 61, 7);
        board[72].setLinks(63, 73, 83, 82, 71, 62, 7);
        board[73].setLinks(64, 74, 84, 83, 72, 63, 7);
        board[74].setLinks(65, 75, 85, 84, 73, 64, 7);
        board[75].setLinks(-1, -1, 86, 85, 74, 65, 3);
        board[76].setLinks(66, 77, 88, 87, -1, -1, 5);
        board[77].setLinks(67, 78, 89, 88, 76, 66, 5);
        board[78].setLinks(68, 79, 90, 89, 77, 67, 7);
        board[79].setLinks(69, 80, 91, 90, 78, 68, 7);
        board[80].setLinks(70, 81, 92, 91, 79, 69, 7);
        board[81].setLinks(71, 82, 93, 92, 80, 70, 7);
        board[82].setLinks(72, 83, 94, 93, 81, 71, 7);
        board[83].setLinks(73, 84, 95, 94, 82, 72, 7);
        board[84].setLinks(74, 85, 96, 95, 83, 73, 7);
        board[85].setLinks(75, 86, 97, 96, 84, 74, 3);
        board[86].setLinks(-1, -1, 98, 97, 85, 75, 3);
        board[87].setLinks(76, 88, 100, 99, -1, -1, 5);
        board[88].setLinks(77, 89, 101, 100, 87, 76, 5);
        board[89].setLinks(78, 90, 102, 101, 88, 77, 5);
        board[90].setLinks(79, 91, 103, 102, 89, 78, 7);
        board[91].setLinks(80, 92, 104, 103, 90, 79, 7);
        board[92].setLinks(81, 93, 105, 104, 91, 80, 7);
        board[93].setLinks(82, 94, 106, 105, 92, 81, 7);
        board[94].setLinks(83, 95, 107, 106, 93, 82, 7);
        board[95].setLinks(84, 96, 108, 107, 94, 83, 7);
        board[96].setLinks(85, 97, 109, 108, 95, 84, 3);
        board[97].setLinks(86, 98, 110, 109, 96, 85, 3);
        board[98].setLinks(-1, -1, 111, 110, 97, 86, 3);
        board[99].setLinks(87, 100, -1, -1, -1, -1, 5);
        board[100].setLinks(88, 101, -1, -1, 99, 87, 5);
        board[101].setLinks(89, 102, -1, -1, 100, 88, 5);
        board[102].setLinks(90, 103, -1, -1, 101, 89, 5);
        board[103].setLinks(91, 104, 112, -1, 102, 90, 7);
        board[104].setLinks(92, 105, 113, 112, 103, 91, 7);
        board[105].setLinks(93, 106, 114, 113, 104, 92, 7);
        board[106].setLinks(94, 107, 115, 114, 105, 93, 7);
        board[107].setLinks(95, 108, -1, 115, 106, 94, 7);
        board[108].setLinks(96, 109, -1, -1, 107, 95, 3);
        board[109].setLinks(97, 110, -1, -1, 108, 96, 3);
        board[110].setLinks(98, 111, -1, -1, 109, 97, 3);
        board[111].setLinks(-1, -1, -1, -1, 110, 98, 3);
        board[112].setLinks(104, 113, 116, -1, -1, 103, 4);
        board[113].setLinks(105, 114, 117, 116, 112, 104, 4);
        board[114].setLinks(106, 115, 118, 117, 113, 105, 4);
        board[115].setLinks(107, -1, -1, 118, 114, 106, 4);
        board[116].setLinks(113, 117, 119, -1, -1, 112, 4);
        board[117].setLinks(114, 118, 120, 119, 116, 113, 4);
        board[118].setLinks(115, -1, -1, 120, 117, 114, 4);
        board[119].setLinks(117, 120, 121, -1, -1, 116, 4);
        board[120].setLinks(118, -1, -1, 121, 119, 117, 4);
        board[121].setLinks(120, -1, -1, -1, -1, 119, 4);
    } /* end initLinks */
    
    /* fill nests => put the pegs in each peg, 
    * init. currentPositions
    * hard cored too
    * */
    private void fillNestOne(int player) {
        board[1].setPeg(player, 1);
        board[2].setPeg(player, 2);
        board[3].setPeg(player, 3);
        board[4].setPeg(player, 4);
        board[5].setPeg(player, 5);
        board[6].setPeg(player, 6);
        board[7].setPeg(player, 7);
        board[8].setPeg(player, 8);
        board[9].setPeg(player, 9);
        board[10].setPeg(player, 10);
        for(int i = 1;i <= 10;i++) {
            currentPositions[player][i] = nests[1][i];
        }
    }
    private void fillNestTwo(int player) {
        board[23].setPeg(player, 1);
        board[22].setPeg(player, 2);
        board[35].setPeg(player, 3);
        board[21].setPeg(player, 4);
        board[34].setPeg(player, 5);
        board[46].setPeg(player, 6);
        board[20].setPeg(player, 7);
        board[33].setPeg(player, 8);
        board[45].setPeg(player, 9);
        board[56].setPeg(player, 10);
        for(int i = 1;i <= 10;i++) {
            currentPositions[player][i] = nests[2][i];
        }
    }
    private void fillNestThree(int player) {
        board[111].setPeg(player, 1);
        board[98].setPeg(player, 2);
        board[110].setPeg(player, 3);
        board[86].setPeg(player, 4);
        board[97].setPeg(player, 5);
        board[109].setPeg(player, 6);
        board[75].setPeg(player, 7);
        board[85].setPeg(player, 8);
        board[96].setPeg(player, 9);
        board[108].setPeg(player, 10);
        for(int i = 1;i <= 10;i++) {
            currentPositions[player][i] = nests[3][i];
        }
    }
    private void fillNestFour(int player) {
        board[121].setPeg(player, 1);
        board[119].setPeg(player, 2);
        board[120].setPeg(player, 3);
        board[116].setPeg(player, 4);
        board[117].setPeg(player, 5);
        board[118].setPeg(player, 6);
        board[112].setPeg(player, 7);
        board[113].setPeg(player, 8);
        board[114].setPeg(player, 9);
        board[115].setPeg(player, 10);
        for(int i = 1;i <= 10;i++) {
            currentPositions[player][i] = nests[4][i];
        }
    }
    private void fillNestFive(int player) {
        board[99].setPeg(player, 1);
        board[100].setPeg(player, 2);
        board[87].setPeg(player, 3);
        board[101].setPeg(player, 4);
        board[88].setPeg(player, 5);
        board[76].setPeg(player, 6);
        board[102].setPeg(player, 7);
        board[89].setPeg(player, 8);
        board[77].setPeg(player, 9);
        board[66].setPeg(player, 10);
        for(int i = 1;i <= 10;i++) {
            currentPositions[player][i] = nests[5][i];
        }
    }
    private void fillNestSix(int player) {
        board[11].setPeg(player, 1);
        board[24].setPeg(player, 2);
        board[12].setPeg(player, 3);
        board[36].setPeg(player, 4);
        board[25].setPeg(player, 5);
        board[13].setPeg(player, 6);
        board[47].setPeg(player, 7);
        board[37].setPeg(player, 8);
        board[26].setPeg(player, 9);
        board[14].setPeg(player, 10);
        for(int i = 1;i <= 10;i++) {
            currentPositions[player][i] = nests[6][i];
        }
    }
    private void initPegs(int[] id) {
        for(int i = 1;i < id.length;i++) {
            switch(id[i]) {
              case 1:
                  fillNestOne(i);
                  break;
              
              case 2:
                  fillNestTwo(i);
                  break;
              
              case 3:
                  fillNestThree(i);
                  break;
              
              case 4:
                  fillNestFour(i);
                  break;
              
              case 5:
                  fillNestFive(i);
                  break;
              
              case 6:
                  fillNestSix(i);default:
            }
        }
    } /* initPegs */
    public int getPlayer(int hole) {
        int[] array;
        array = board[hole].getPeg();
        return (array[0]);
    }
    public int getPeg(int hole) {
        int[] tmp;
        tmp = board[hole].getPeg();
        return (tmp[1]);
    }
    public boolean checkMovement(int player, int pegNumber, int[] directions) {
        int i, dir;
        int pegPosition; /* current position of the peg */
        int tmpPosition;
        boolean jumping = false; /* for not messing jumps with single movs. */
        int peg = pegNumber;
        if(peg == 0) {
            peg = 10;
        }
        if(player == -1) {
            return (false);
        }
        pegPosition = currentPositions[player][peg];
        for(i = 0;i < directions.length;i++) {
            dir = directions[i];
            tmpPosition = board[pegPosition].getNeighbours(dir);
            if(tmpPosition != -1) {
                if(board[tmpPosition].isOccupied() == true) {
                     
                     /* It's a jump */
                     {
                        jumping = true;
                        tmpPosition = board[tmpPosition].getNeighbours(dir);
                        if(board[tmpPosition].isOccupied() == true) {
                            return (false);
                        }
                        else {
                            pegPosition = tmpPosition;
                        }
                    }
                }
                else { /* a single movement */
                    if(jumping) {
                        return (false);
                    }
                    else {
                        if(i == directions.length - 1) {
                            return (true);
                        }
                        else {
                            return (false);
                        }
                    }
                }
            }
            else {
                return (false);
            } /* if tmpPosition != -1 */
        } /* for */
        return (true);
    } /* end checkMovement */
    public void update(int player, int pegNumber, int finalHole) 
                                                                 /* this method should only be used by the server after checking
                                                                 * the movement (?) -> And also the clients after receiving the movement.
                                                                 * */
                                                                 {
        int peg = pegNumber;
        if(peg == 0) {
            peg = 10;
        }
        int startHole = currentPositions[player][peg];
        board[startHole].free();
        board[finalHole].setPeg(player, peg);
        currentPositions[player][peg] = finalHole;
    }
    public boolean[] winner() 
                              /* this method return a boolean array each element is a player
                              * if true, the player is a winner
                              * if false, the player is a not winner :P
                              * */
                              {
        int i, j, k;
        boolean[] arrayWinners = new boolean[id[0] + 1];
        boolean end = false;
        int count = 0;
        for(i = 1;i <= id[0];i++) {
            count = 0;
            for(j = 1;j <= 10;j++) {
                end = false;
                for(k = 1;k <= 10 && !end;k++) {
                    if(currentPositions[i][j] == nests[((id[i] + 2) % 6) + 1][k]) {
                        end = true;
                    }
                }
                if(end) {
                    count++;
                }
            }
            if(count == 10) {
                arrayWinners[i] = true;
            }
            else {
                arrayWinners[i] = false;
            }
        }
        return (arrayWinners);
    }
    public int getNPlayers() {
        return (id[0]);
    }
    
    //If the first component of the returned array is -1
    
    //This is an incorrect move
    public int[] holesToDirections(String holes) {
        int tmp;
        int index;
        int index2;
        int[] out;
        int[] retValue;
        int counter = 0;
        int i, dir;
        boolean found = false;
        for(i = 0;i < holes.length();i++) {
            if(holes.charAt(i) == ',') {
                counter++;
            }
        }
        if(counter == 0) { //If we have no commas is because we have only one hole
            retValue = new int[2]; // When you doubleclick in the first chosen hole
            retValue[0] = -1;
            retValue[1] = 0;
            return (retValue);
        }
        out = new int[counter + 1];
        retValue = new int[counter + 2];
        index = holes.indexOf(",");
        tmp = Integer.parseInt(holes.substring(0, index));
        out[0] = tmp;
        retValue[0] = getPlayer(tmp);
        retValue[1] = getPeg(tmp);
        if(retValue[1] == 10) {
            retValue[1] = 0;
        }
        for(i = 0;i < counter;i++) {
            index2 = holes.indexOf(",", index + 1);
            if(index2 == -1) {
                out[i + 1] = Integer.parseInt(holes.substring(index + 1, holes.length()));
            }
            else {
                out[i + 1] = Integer.parseInt(holes.substring(index + 1, index2));
            }
            index = index2;
        }
        if(counter == 1) {
            for(dir = 1;dir <= 6;dir++) {
                tmp = board[out[0]].getNeighbours(dir);
                if(tmp != -1) {
                    if(board[tmp].getNeighbours(dir) == out[1]) {
                        if(board[tmp].isOccupied() == false) {
                            retValue[0] = -1;
                            return (retValue);
                        }
                    }
                }
            }
        }
        for(i = 0;i < counter;i++) {
            if(board[out[i + 1]].isOccupied()) {
                retValue[0] = -1;
                return (retValue);
            }
        }
        for(i = 0;i < counter;i++) {
            found = false;
            for(dir = 1;dir <= 6 && !found;dir++) {
                tmp = board[out[i]].getNeighbours(dir);
                if(tmp == out[i + 1]) {
                    retValue[i + 2] = dir;
                    found = true;
                }
                else {
                    if(tmp != -1) {
                        if(board[tmp].getNeighbours(dir) == out[i + 1]) {
                            retValue[i + 2] = dir;
                            found = true;
                        }
                    }
                }
            }
            if(!found) {
                retValue[0] = -1;
                return (retValue);
            }
        }
        return (retValue);
    }
    public int getOppositeNest(int myID) {
        return (((id[myID] + 2) % 6) + 1);
    }
    public boolean inNest(int h, int ID)  /* return true if h is in nest ID. Otherwise false*/{
        int i;
        for(i = 1;i <= 10;i++) {
            if(h == nests[ID][i]) {
                return (true);
            }
        }
        return (false);
    }
    public int getNeighbours(int i, int direction) {
        int j;
        j = board[i].getNeighbours(direction);
        return (j);
    }
    public int getHole(int myID, int peg) {
        return (currentPositions[id[myID]][peg]);
    }
} /* end board */
