
/*
* See board.java for information...
*
*/
package pkBoard;

/**
 * Class hole
 * @Version 0
 * @Author Csar Prez <perces-1@student.luth.se>
 * Date: 5 November 2001
 * Methods:
 * 	setLinks	set the links for a hole 
 * 	setPeg		"put" a peg in the hole 
 * 	free		remove a peg from the hole 
 * 	isOccupied	is there a peg in this hole? 
 * 	getPeg		which peg is in this hole?
 * 	getNeighbours	which neighbour do I have in a given direction
 * */
class hole {
    final protected int[] links = new int[7];
    protected boolean occupied = false;
    protected int zone; // 1-6: nest 1 to 6
    
    //   7: neutral zone
    
    /* these are only use if occupied = true. */
    protected int nPlayer; /* number of the player 1..6 */
    protected int nPeg; /* number of peg 1..10 */
    
    /********* METHODS *************/
    protected void setLinks(int first, int second, int third, int forth, int fith, int sixth, int zone) {
        this.links[1] = first;
        this.links[2] = second;
        this.links[3] = third;
        this.links[4] = forth;
        this.links[5] = fith;
        this.links[6] = sixth;
        this.zone = zone;
    }
    protected void setPeg(int player, int peg) {
        this.nPlayer = player;
        this.nPeg = peg;
        this.occupied = true;
    }
    
    /* when we move a peg and leave the hole empty we should 
    * use this method */
    protected void free() {
        this.occupied = false;
    }
    protected boolean isOccupied() {
        return (this.occupied);
    }
    
    /* the first position of the array is the Player
    * and the second one is the peg */
    protected int[] getPeg() {
        int[] array = new int[2];
        array[0] = 0;
        array[1] = 0;
        if(this.occupied) {
            array[0] = this.nPlayer;
            array[1] = this.nPeg;
        }
        return (array);
    }
    protected int getNeighbours(int direction) {
        if(direction >= 1 && direction <= 6) {
            return (this.links[direction]);
        }
        else {
            return (-1);
        }
    }
} /* end hole */
