
/**
 * Class Client
 * @Version 0
 * @Author Oscar Bonilla Gonzales <osabon-1@student.luth.se>
 * @Author Jens Held <jenhel-0@student.luth.se>
 * @Author Camilla Isberg <camisb-6@student.luth.se>
 * @Author Cesar Perez Turrado <cesper-1@student.luth.se>
 * @Author Marie Rekonius <marrek-9@student.luth.se>
 * Date:  14 November 2001
 * Last Revision: 6 December 2001 
 * Methods:
 * void clientStart ()
 * getOurTurn () 
 * connectingToServer (String hostName, String port)
 * sendMovementToServer (String message)
 * int getPlayer (int hole2)
 */
package pkClient;
import pkBoard.*;
import pkNet.*;
import java.awt.*;
class Client {
    protected networking net = new networking();
    protected Board board;
    protected int playerID;
    protected boolean ourTurn = false;
    private GUI gui;
    public void clientStart() {
        gui = new GUI(this);
        gui.startGUI();
    }
    
    //Get ourTurn
    protected boolean getOurTurn() {
        return (this.ourTurn);
    }
    
    // methods not for the GUI 
    protected boolean connectingToServer(String hostName, String port) {
        boolean success = true;
        int[] id;
        int[] tmp = null;
        try {
            net.connect(hostName, Integer.parseInt(port));
            id = net.receiveId();
            playerID = id[id[0] + 1]; //My ID
            tmp = new int[id[0] + 2];
            System.arraycopy(id, 0, tmp, 0, id[0] + 1);
            
            //We send only "nPlayers" components of the array. The last one is our id.
            board = new Board(tmp);
            gui.ourRepaint();
        }
        catch(Exception e) {
            success = false;
        }
        return (success);
    }
    protected void sendMovementToServer(String message) {
        try {
            net.clientSendMovement(message);
        }
        catch(Exception e) {
            System.out.println("Can't send movement to the server");
            System.exit(0);
        }
    }
    protected int getPlayer(int hole2) {
        return (board.getPlayer(hole2 + 1));
    }
}
