package pkClientBot;
import java.util.*;
import pkBoard.*;

/**
 * Class AIDavid 
 * @Version 0
 * @Author Csar Prez <perces-1@student.luth.se>
 * Date: December 2001
 * Methods and use:
 * 	botBrain = new AIDavid (myClient);
 * 	movements = botBrain.newMovemtn();
 *
 * Why the name? 'cos the main caracter of Spielbergs/Kubrick's "AI Artificial
 * Intelligence" is called David. Quite silly, isn't it?
 *
 * */
class AIDavid {
    Score score;
    Movements movements;
    int ID;
    Board board;
    public AIDavid(Client myClient) {
        ID = myClient.playerID;
        board = myClient.board;
        score = new Score(board, ID);
        movements = new Movements(board, ID);
    }
    public String newMovement() {
        
        /* improvements:
        * 	1) IMPORTANT: It's screwed up when it arrives to the 
        * 			"goal nest"
        * 	2) Maybe not make the farest jump. But one of the farest
        * 		or nearly farest (ramdomly, more weight to the
        * 		fares...)
        * 	3) It could be improved adding more complex rules (i.e. 
        * 		taking into account future movements) but I like
        * 		more the idea of the system being able to learn
        * 		(i.e. Building stairs "jump over a peg from
        * 		right to left; moving that peg to upleft..."
        * 		it can learn that when it does these kinds of
        * 		movements it's able to make longer jumps, etc, etc).
        *
        * */
        String string;
        MovementsList list = new MovementsList();
        int i, j;
        int scr = 666 * 666;
        int[] pegAndHole;
        movements.calculate();
        for(i = 1;i <= 10;i++) {
            for(j = 1;j <= 121;j++) {
                if(movements.existMovement(i, j)) {
                    if(score.getScore(board.getHole(ID, i)) != 0) {
                        if(score.getScore(board.getHole(ID, i)) > score.getScore(j)) {
                            if(scr > score.getScore(j)) {
                                scr = score.getScore(j);
                                list.delete();
                                list.add(i, j);
                            }
                            else {
                                if(scr == score.getScore(j)) {
                                    list.add(i, j);
                                }
                            }
                        }
                    }
                }
            }
        }
        if(list.empty()) {
            string = "";
        }
        else {
            pegAndHole = list.choose();
            list.delete();
            string = movements.getMovement(pegAndHole[0], pegAndHole[1]);
        }
        return (string);
    }
}

/**
 * Class  MovementsList
 * @Version 0
 * @Author Csar Prez <perces-1@student.luth.se>
 * Date: December 2001
 * Methods and use:
 * 	MovementsList list = new MovementsList();
 * 	boolean = list.empty() return true if the list is empty
 * 	list.delete() will delete the list
 * 	list.add(peg, hole) will insert peg and hole in the list
 * 	int[2] = list.choose() will choose a pair of peg/hole from the list
 * 					first component peg
 * 					second componet hole
 *
 * */
class MovementsList {
    ArrayList listPeg = new ArrayList();
    ArrayList listHole = new ArrayList();
    protected boolean empty()  /* return true if the list is empty*/{
        if(listPeg.size() == 0) {
            return (true);
        }
        else {
            return (false);
        }
    }
    protected int[] choose()  /* return an array of two components (0: #peg; 1: #hole)*/{
        int position, size;
        int[] array = new int[2];
        String str;
        size = listPeg.size();
        if(size != listHole.size()) {
            System.out.println("Something vere weird happened. I'll try tho continue...");
        }
        position = (int)(Math.random() * size);
        
        // A more sane way of converting a list-component to int?
        str = "" + listPeg.get(position);
        array[0] = Integer.parseInt(str);
        str = "" + listHole.get(position);
        array[1] = Integer.parseInt(str);
        return (array);
    }
    protected void add(int peg, int hole)  /* add a peg and hole to the list*/{
        listPeg.add(new Integer(peg));
        listHole.add(new Integer(hole));
    }
    protected void delete()  /*/ delete the list*/{
        int i, index;
        index = listPeg.size();
        if(index != listHole.size()) {
            System.out.println("Something vere weird happened. I'll try tho continue...");
        }
        for(i = index - 1;i >= 0;i--) {
            listPeg.remove(i);
            listHole.remove(i);
        }
    }
}
