package pkClientBot;
import java.util.*;
import pkBoard.*;

/**
 * Class Movement
 * @Version 0
 * @Author Csar Prez <perces-1@student.luth.se>
 * Date: December 2001
 * Methods and use:
 *      Movements m = new Movements (board, id);
 *	public void calculate ()
 *	public String getMovement (int peg, int hole)
 *	public boolean getMovement (int peg, int hole)
 *
 * */
class Movement {
    String movement;
    Movement(ArrayList list) {
        int i, size;
        movement = "";
        size = list.size();
        for(i = 0;i < size - 1;i++) {
            movement = movement + list.get(i) + ",";
        }
        movement = movement + list.get(size - 1);
    }
    String getMovement() {
        return (movement);
    }
}

/**
 * Class Movements 
 * @Version 0
 * @Author Csar Prez <perces-1@student.luth.se>
 * Date: December 2001
 * Methods and use:
 *
 * */
class Movements {
    Board board;
    int ID;
    
    // these are a bit obscure.
    
    // peg is modified in calculate and use in add()
    
    // *List is use in add(), push() and pop()
    int peg;
    ArrayList visitedList = new ArrayList();
    ArrayList movementList = new ArrayList();
    Movement[][] arrayMovements = new Movement[10][121];
    public Movements(Board myBoard, int myID) {
        int i;
        board = myBoard;
        ID = myID;
    }
    void add() {
        String str = "" + movementList.get(movementList.size() - 1);
        arrayMovements[peg - 1][Integer.parseInt(str) - 1] = new Movement(movementList);
    }
    boolean valid(int hole) {
        
        /*
        if (hole == -1)
        return (false);
        return (visitedList.contains(new Integer (Hole)));
        */
        return ((hole != -1) && !visitedList.contains(new Integer(hole)));
    }
    void push(int hole) {
        visitedList.add(new Integer(hole));
        movementList.add(new Integer(hole));
    }
    void pop() {
        movementList.remove(movementList.size() - 1);
    }
    void calculatePegMovements(int hole, boolean firstTime) {
        int currentHole;
        int i;
        for(i = 1;i <= 6;i++) {
            currentHole = board.getNeighbours(hole, i);
            if(valid(currentHole)) {
                if(board.getPlayer(currentHole) != 0) /*jump*/ {
                    currentHole = board.getNeighbours(currentHole, i);
                    if(valid(currentHole)) {
                        if(board.getPlayer(currentHole) == 0) {
                            push(currentHole);
                            add();
                            calculatePegMovements(currentHole, false);
                            pop();
                        }
                    }
                }
                else {
                    if(firstTime) { //simple movement
                        push(currentHole);
                        add();
                        pop();
                    }
                }
            }
        }
    }
    void clean() {
        int i, index;
        index = visitedList.size();
        for(i = index - 1;i >= 0;i--) {
            visitedList.remove(i);
        }
        index = movementList.size();
        for(i = index - 1;i >= 0;i--) {
            movementList.remove(i);
        }
        for(i = 0;i < 121;i++) {
            arrayMovements[peg - 1][i] = null;
        }
    
    // I hope the garbage collector will pick up the movement classes...
    }
    public void calculate() {
        for(peg = 1;peg <= 10;peg++) {
            clean();
            push(board.getHole(ID, peg));
            calculatePegMovements(board.getHole(ID, peg), true);
        }
    }
    public boolean existMovement(int peg, int hole) {
        if(arrayMovements[peg - 1][hole - 1] == null) {
            return (false);
        }
        else {
            return (true);
        }
    }
    public String getMovement(int peg, int hole) {
        if(arrayMovements[peg - 1][hole - 1] == null) {
            return ("");
        }
        else {
            return (arrayMovements[peg - 1][hole - 1].getMovement());
        }
    }
}
