package pkClientBot;
import pkBoard.*;
import pkNet.*;
import java.awt.*;
class Play extends Thread {
    
    // this thread is stopped by using the setEnd method
    private boolean end = false;
    Client client;
    BoardCanvas bc;
    TextArea txtArea;
    GUI gui;
    AIDavid aidavid;
    public Play(Client myClient, BoardCanvas myBc, GUI myGUI, TextArea textArea) {
        client = myClient;
        bc = myBc;
        txtArea = textArea;
        gui = myGUI;
    }
    protected void setEnd() {
        end = true;
    }
    protected synchronized void notification() {
        notifyAll();
    }
    public synchronized void run() {
        int[] move;
        int counter = 0;
        int[] win = new int[6];
        boolean[] winners;
        
        // Carajo, qu chapuza!
        String[] colors =  {
            "", "red", "blue", "black", "green", "yellow", "cyan"
        };
        aidavid = new AIDavid(client);
        try {
            while(!end) {
                for(int i = 1;(i <= client.board.getNPlayers()) && !end;i++) {
                    if(i == client.playerID) { //It's our turn
                        gui.txtArea.setText("");
                        gui.txtArea.append("Waiting my turn...");
                        client.net.waitTurn();
                        
                        //client.ourTurn = true;
                        gui.txtArea.setText("");
                        gui.txtArea.append("It's my turn: thinking");
                        client.sendMovementToServer(aidavid.newMovement());
                        try {
                            if(client.net.wasOK() == false) {
                                gui.txtArea.setText("");
                                gui.txtArea.append("Ooops! The movement was wrong. I'm supposed to make correct movements. I'm very depressed :(");
                                sleep(6000);
                                gui.txtArea.setText("");
                                gui.txtArea.append("I'm sooo depressed. I'll commite suicide. Sorry.");
                                sleep(3000);
                                gui.txtArea.setText("");
                                gui.txtArea.append("Adios mundo cruel!");
                                sleep(100);
                                System.exit(-1);
                            }
                        }
                        catch(Exception exception) {
                            System.out.println("Error receiving reply to movement");
                            System.exit(-1);
                        }
                    
                    /*
                    * vi r ensam
                    * 
                    gui.txtArea.append("It's my turn: waiting");
                    //Wait for notification
                    try {
                    wait(0);
                    } catch (Exception myException) {
                    }
                    client.ourTurn = false;
                    */
                    }
                    move = client.net.clientReceiveMovement();
                    client.board.update(move[0], move[1], move[2]);
                    bc.repaint();
                } //for
                if(client.net.endOfGame() == true) {
                    winners = client.net.receiveWinners();
                    
                    //End the game & show winners
                    end = true;
                    gui.txtArea.setText("");
                    for(int j = 1;j <= client.board.getNPlayers();j++) {
                        if(winners[j] == true) {
                            counter++;
                            win[counter - 1] = j;
                        }
                    }
                    if(counter == 1) {
                        gui.txtArea.append("And the winner is: player " + colors[win[0]]);
                    }
                    else {
                        gui.txtArea.append("And the winners are:");
                        for(int k = 0;k < counter;k++) {
                            gui.txtArea.append(" Player " + colors[win[k]]);
                        }
                    }
                    gui.txtArea.append("\nIf you want to play again press Exit and restart the server and clients");
                }
            } //while (!end)
        }
        catch(Exception e) {
            System.out.println("Error in thread play. Contact your dealer");
            System.exit(-1);
        }
    }
}
