package pkClientBot;
import java.util.*;
import pkBoard.*;

/**
 * Class Score
 * @Version 0
 * @Author Csar Prez <perces-1@student.luth.se>
 * Date: December 2001
 * Methods and use:
 * 	score myScore = new Score(First hole of the opposite nest);
 *	int getScore (hole);
 *
 *	This class will asign a score to each hole. It doesn't take into account
 *	the pegs positions, in order to do this another method for updating the
 *	score would be needed.
 *
 *	The lower the score is the better. If the score is 0, then the peg is in the
 *	nest. (FIXME: if we're in the opposite nest we don't know how far we are
 *	from the first hole of thar nest)
 */
class Score {
    int[] scores = new int[122];
    Board board;
    int ID; // my ID aka my zone
    private int min(int[] array)  /* return the minimun element of the array*/{
        int i, m;
        m = 666 * 666;
        for(i = 0;i < array.length;i++) {
            if(array[i] < m && array[i] > -1) {
                m = array[i];
            }
        }
        return (m);
    }
    private int zigzag(int sentido1, int sentido2, int position)  /* return distance from 'position' to the "goalnest" moving first*/ /* (spanish: alternativamente) in direction 'sentido1' and later */ /* in 'sentido2'*/{
        int dist;
        int neighbour;
        if(board.inNest(position, ID)) {
            return (0);
        }
        neighbour = board.getNeighbours(position, sentido1);
        if(neighbour == -1) {
            return (-1);
        }
        dist = zigzag(sentido2, sentido1, neighbour);
        if(dist == -1) {
            return (dist);
        }
        else {
            return (dist + 1);
        }
    }
    private int linearecta(int sentido, int position)  /* return distance from 'position' to the "goalnets" moving in*/ /* direction 'sentido'*/{
        int dist1, dist2, j, se1, se2;
        int[] dista = new int[12];
        int neighbour, ret;
        dist1 = 0;
        dist2 = 0;
        if(board.inNest(position, ID)) {
            return (0);
        }
        neighbour = board.getNeighbours(position, sentido);
        if(neighbour == -1) {
            return (-1);
        }
        dist1 = linearecta(sentido, neighbour);
        for(j = 0;j < 6;j++) {
            se1 = j + 1;
            se2 = se1 + 1;
            if(se2 > 6) {
                se2 = 1;
            }
            dista[j] = zigzag(se1, se2, position);
            dista[j + 6] = zigzag(se2, se1, position);
        }
        dist2 = min(dista);
        if(dist1 == -1) {
            if(dist2 == -1) {
                ret = -1;
            }
            else {
                ret = dist2 + 1;
            }
        }
        else {
            if(dist2 == -1) {
                ret = dist1 + 1;
            }
            else {
                if(dist2 < dist1) {
                    ret = dist2 + 1;
                }
                else {
                    ret = dist1 + 1;
                }
            }
        }
        return (ret);
    }
    private int distance(int from) {
        int i, s1, s2;
        int[] distances = new int[18];
        if(board.inNest(from, ID)) {
            return (0);
        }
        for(i = 0;i < 6;i++) {
            distances[i] = linearecta(i + 1, from);
        }
        for(i = 6;i < 12;i++) {
            s1 = i - 5;
            s2 = s1 + 1;
            if(s2 > 6) {
                s2 = 1;
            }
            distances[i] = zigzag(s1, s2, from);
            distances[i + 6] = zigzag(s2, s1, from);
        }
        
        /*
        System.out.println (""+from+"="+min(distances)+"     "+distances[0]
        +" "+distances[1]+" "+distances[2]+" "+distances[3]
        +" "+distances[4]+" "+distances[5]+" "+distances[6]
        +" "+distances[7]+" "+distances[8]+" "+distances[9]
        +" "+distances[10]+" "+distances[11]);
        */
        return (min(distances));
    }
    public Score(Board myBoard, int myID) {
        int i;
        board = myBoard;
        ID = board.getOppositeNest(myID);
        for(i = 1;i < 122;i++) {
            scores[i] = distance(i);
        }
    }
    public int getScore(int i) {
        return (scores[i]);
    }
}
