
/**
 * Class server
 * @Version 0
 * @Author Csar Prez <perces-1@student.luth.se>
 * @Author scar Bonilla <osabon-1@student.luth.se>
 * Date: 13 November 2001
 * Attributes:
 *	
 * Methods:
 *	
 */

/** Imports */
import java.io.*;
import pkBoard.*;
import pkNet.*;
public class server {
    public static void main(String args[]) {
        networking net = new networking();
        final int defaultPort = 4321;
        Board board;
        int nPlayers = 0;
        int id[];
        int player;
        String message;
        int move[];
        int tmp[] = null;
        boolean end = false;
        boolean[] winners;
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        while(nPlayers != 2 && nPlayers != 4 && nPlayers != 6) {
            System.out.println("Enter number of players: ");
            try {
                String tmp2;
                tmp2 = in.readLine();
                nPlayers = Integer.parseInt(tmp2);
            }
            catch(Exception k) {
                System.out.println("Can't read number of players");
                System.exit(1);
            }
        }
        System.out.println("Server waiting for client connections.");
        id = new int[nPlayers + 1];
        winners = new boolean[nPlayers + 1];
        try {
            net.waitForConnection(nPlayers, defaultPort);
            System.out.println("All the players are connected.");
            switch(nPlayers) {
              case 2:
                  id[0] = 2;
                  id[1] = 1;
                  id[2] = 4;
                  break;
              
              case 4:
                  id[0] = 4;
                  id[1] = 2;
                  id[2] = 3;
                  id[3] = 5;
                  id[4] = 6;
                  break;
              
              case 6:
                  id[0] = 6;
                  id[1] = 1;
                  id[2] = 2;
                  id[3] = 3;
                  id[4] = 4;
                  id[5] = 5;
                  id[6] = 6;
                  break;default:
            } //switch
            board = new Board(id);
            for(int i = 1;i <= nPlayers;i++) {
                net.sendId(i, id);
            }
            net.waitReady();
            
            /** Start playing */
            while(!end) { //If (end of game) then exit the loop
                for(player = 1;player <= nPlayers;player++) { //For each player
                    net.sendTurn(player);
                    message = net.serverReceiveMovement(player);
                    move = board.holesToDirections(message);
                    tmp = new int[move.length - 2];
                    System.arraycopy(move, 2, tmp, 0, move.length - 2);
                    if(player != move[0]) { //Don't move a peg that is not yours...
                        move[0] = -1;
                    }
                    while(board.checkMovement(move[0], move[1], tmp) == false) {
                        net.sendNotOK(player);
                        message = net.serverReceiveMovement(player);
                        move = board.holesToDirections(message);
                        tmp = new int[move.length - 2];
                        System.arraycopy(move, 2, tmp, 0, move.length - 2);
                        if(player != move[0]) { //Don't move a peg that is not yours...
                            move[0] = -1;
                        }
                    }
                    net.sendOK(player);
                    int tmp2 = message.lastIndexOf(",");
                    int finalHole = Integer.parseInt(message.substring(tmp2 + 1, message.length()));
                    board.update(player, move[1], finalHole);
                    for(int i = 1;i <= nPlayers;i++) {
                        net.serverSendMovement(i, move[0], move[1], finalHole);
                    }
                } //Turn loop
                
                // board.checkWinner  if (winner) then send endOfGame and then the winners and exit the loop
                
                //			else send not endOfGame
                winners = board.winner();
                for(int i = 1;i <= nPlayers && !end;i++) {
                    if(winners[i] == true) {
                        end = true;
                    }
                }
                if(end) {
                    for(int i = 1;i <= nPlayers;i++) {
                        net.sendEnd(i, true);
                        net.sendWinners(i, winners);
                    }
                }
                else {
                    for(int i = 1;i <= nPlayers;i++) {
                        net.sendEnd(i, false);
                    }
                }
            } //Loop until end of game
        }
        catch(Exception e) { //Send message to all the clients
            for(int i = 1;i <= nPlayers;i++) {
                try {
                    net.serverSendExit(i, true);
                }
                catch(Exception x) {
                    
                }
            }
        }
    }
}
